Closed Bug 830040 Opened 7 years ago Closed 6 years ago

[music][bluetooth] Undiscoverable UI to initiate bluetooth file transfer

Categories

(Firefox OS Graveyard :: Gaia::Music, defect, P1)

Other
Gonk (Firefox OS)
defect

Tracking

(blocking-b2g:koi+, b2g18+, b2g-v1.2 fixed)

RESOLVED FIXED
1.2 FC (16sep)
blocking-b2g koi+
Tracking Status
b2g18 + ---
b2g-v1.2 --- fixed

People

(Reporter: parul, Assigned: mahsam.29)

References

Details

(Whiteboard: [EU_TPE_TRIAGED] leorun3, leorun4, retest_leorun4, mentor=dkuo)

Attachments

(7 files)

Test Environment:
Device: unagi phone
Build Identifier: 20130111230201
Update channel: nightly
Git commit info: 2013-11-11 15:13:02 df38c1
Gaia Version: 45a3196a5517
Gecko Version: 8f2ef4998b60

Steps to reproduce:
1. Go to Settings and turn on Bluetooth.
2. Pair the phone with another device, like a laptop.
3. Attempt to send a music file on the phone to the laptop. 

Actual results:
There doesn't seem to be a way to send a music file on the phone to the laptop. The Music app doesn't have a share button for music files.

Expected results:
There should be a way to send a music file on the phone to the laptop. 
Use Case: Music-027 As a user I can share my music via bluetooth file transfer.

As per clarification received via email:
-------
Subject: Re: Music: Use case mapping to what is implemented in current builds
Date: Wed, 9 Jan 2013 16:14:43 -0800
From: Chris Lee <clee@mozilla.com>
To: Peter Dolanjski <pdolanjski@mozilla.com>
CC: Marcia Knous <marcia@mozilla.org>, Patryk Adamczyk <padamczyk@mozilla.com>, Chris Double <cdouble@mozilla.com> 

> Question: Does "sharing" mean _receive_ music files on the phone via
> bluetooth and also _send_ music files from the phone via bluetooth to
> another device? 
Yes, sharing means receiving and sending music to another device. 

Chris 

-------
Subject: Re: Music: Use case mapping to what is implemented in current builds
Date: Wed, 9 Jan 2013 15:41:06 -0800 (PST)
From: Peter Dolanjski <pdolanjski@mozilla.com>
To: Marcia Knous <marcia@mozilla.org>
CC: Chris Lee <clee@mozilla.com>, Patryk Adamczyk <padamczyk@mozilla.com>,  Chris Double <cdouble@mozilla.com> 

Bluetooth file transfer:
This includes sending and receiving music files, yes.

Peter
blocking-b2g: --- → tef?
blocking-basecamp: --- → ?
blocking-kilimanjaro: --- → ?
OS: Windows 7 → Gonk (Firefox OS)
Hardware: x86 → Other
blocking-basecamp: ? → ---
blocking-kilimanjaro: ? → ---
tracking-b2g18: --- → ?
blocking-b2g: tef? → tef+
Keywords: qawanted
Press and hold on a song to share it via bluetooth.

Yes, the UX sucks. But the feature is there, or it was, at least.

Casey was going to investigate a better UX, with a share button. What do you think, Casey, should we add a visible and discoverable share button?
Flags: needinfo?(kyee)
Thanks David, I almost missed this one...

I am sure we are able to share a song in Music app via bluetooth.
Just like David said, Press and hold on a song will trigger the bluetooth app to transfer that song.
Press and hold on a song triggers a screen that says "Choose your option" and lists the paired bluetooth devices. (See screenshot attached). Nowhere on the screen does it actually say "Bluetooth transfer" or even the word "Bluetooth".
Assignee: nobody → echou
Whiteboard: [EU_TPE_TRIAGED]
Agreed that this is horrible UX. It wouldn't be hard to fix. We can slap a share icon in there somewhere. But we need guidance fro UX.

Dominic or I would be better assignees for this bug, I think. Feel free to reassign Eric if you have other tef+ bugs.
Thanks David, I should be the right person to take this.
Assigning this to myself.
Assignee: echou → dkuo
The BT features have been wedged into the existing UX to avoid any substantial changes to the navigation structures for Music and has unfortunately resulted in the share feature being buried and difficult to find.

Ideally we should have a select and share option similar to what we have in Gallery.  
The problem is that we don't really have any room in the current UI to add the extra button. 

I will need to find some time in the next few weeks to address this and some other UX issues in music app.   I will post updates to this bug with progress.
Flags: needinfo?(kyee)
Seeing that this is a TEF+ bug we'll need a quicker solution.   

Adding a share icon to the now playing screen in the area where we have the repeat, rating and shuffle icons seems like a good solution.

Adding Peter for Visual Design support.
Flags: needinfo?(pla)
Updated the title to reflect the real bug here -- BT music transfer does work, it's just hard to find. 

Also re-nominating for triagers to verify that we're blocking this on improving the UI and not on the basic functionality of the feature.
blocking-b2g: tef+ → tef?
Summary: [music][bluetooth] No way to send music from phone to another device via bluetooth file transfer → [music][bluetooth] Undiscoverable UI to initiate bluetooth file transfer
Hi,

After discussing with Patryk, we feel the share icon would be better off residing in either the header or the transparent overlay underneath the header.  See mockup (Options 1 & 2).  In the header, it would be in the same position as the 'Now Playing' icon.

Option 1
Pros: Always visible, discoverability is high.
Cons: Leaves a little less space for song titles.

Option 2
Pros: Song titles have the full header.
Cons: Not as discoverable.

Our first recommendation would be Option 1, but Option 2 is also acceptable.
Flags: needinfo?(pla)
Attached image Share Icon
Use this asset for implementation.
Great, both options looks good, and should be no problem to implement.
This is not something we'll hold the 1.0 release on. Tracking+ for fixing in a subsequent release.
blocking-b2g: tef? → -
Removing qawanted because at this point I don't see anything actionable for QA to investigate.
Keywords: qawanted
Bug 832368 is talking about some UI tweak on bluetooth transfer, and people think the share feature is hard to find in Music app, so I guess it's time to make this leo+ and implement it.
blocking-b2g: - → leo?
Hi,

Current approach "Press and hold on a song to share it via bluetooth" is not working for me in the following scenarios:

Test Environments:
v1.0.1
Device: buri phone
Git commit info: 2013-05-17 09:25:00; 745a8da49cf21728714e3cde8358224

&

v1.1
Device: unagi phone
Build Identifier: 20130530100218
Update channel: nightly
Git commit info: 2013-05-30 08:03:38; 5919649b3ab60759ad2b55dc7e38b4c

might it be a regression?

Thanks,
I don't have a buri but I can trigger the sharing funtion on unagi by pressing and holding on a song, so this is not a regression I think.
blocking-b2g: leo? → -
Flags: needinfo?(firefoxos-ux-bugzilla)
partners ask to needs ux team
Assigning to Casey only since he helped out on this one previously. Sorry, Casey! ;)
Flags: needinfo?(firefoxos-ux-bugzilla) → needinfo?(kyee)
Flags: needinfo?(kyee) → needinfo?(fdjabri)
I'm not sure what further UX input is needed for this bug above and beyond what Peter recommended in comment #10 - please could you clarify.
Flags: needinfo?(fdjabri)
(In reply to Dominic Kuo [:dkuo] from comment #17)
> I don't have a buri but I can trigger the sharing funtion on unagi by
> pressing and holding on a song, so this is not a regression I think.

I'm not able to share files via BT from "grid" (first option) and "Songs" views, it works for me from "Playlist", "Artists" and "Albums". Is it like this by design?.

Thanks,
Issue repros on 
Leo Build ID: 20130610070206
Gecko: http://hg.mozilla.org/releases/mozilla-b2g18/rev/8e3f39363c54
Gaia: ce3b99781d182ad550a325206990c249b0dbcf0e
Platform Version: 18.0

When pressing and holding on a song no option displays to share song via bluetooth.
Whiteboard: [EU_TPE_TRIAGED] → [EU_TPE_TRIAGED] leorun3
Blocking on this.   I don't see a decision coming together here, and we're two releases out by now.  Have we agreed on a solution to this yet?
blocking-b2g: - → leo?
Per Francis' comment 20, what is needed beyond what Peter recommended in comment 10?
(In reply to Noemí Freire (:noemi) from comment #21)
> I'm not able to share files via BT from "grid" (first option) and "Songs"
> views, it works for me from "Playlist", "Artists" and "Albums". Is it like
> this by design?.

The "grid" view shows albums not songs so that's by design, and for "all songs" view that's really a bug, sorry I thought we are talking about the songs from "Playlist", "Artists" and "Albums" view.

To fix this and make the sharing UI more discoverable for Music app, I am going to implement one of the options in comment 10.

> Our first recommendation would be Option 1, but Option 2 is also acceptable.

Peter, we want option 1, is that correct?
Flags: needinfo?(pla)
Flagging Casey for UX since Bluetooth is one of the component areas he handles.
Flags: needinfo?(kyee)
Hi Dominic,

After speaking with Patryk about this, we felt Option 1 is the best.  However, I'd be interested in Casey's opinion on this as well.
Flags: needinfo?(pla)
Flags: needinfo?(kyee) → needinfo?(rmacdonald)
Issue repros on 
Leo Build ID: 20130625070217
Gecko: http://hg.mozilla.org/releases/mozilla-b2g18/rev/29933d1937db
Gaia: 1436e2778b90bd74635b0b94d1cf8ccb0d71b60c
Platform Version: 18.1

Unable to share files on "Music" grid, and in Song view however it does work in "Playlists", "Albums" and "Artists"
Whiteboard: [EU_TPE_TRIAGED] leorun3 → [EU_TPE_TRIAGED] leorun3, leorun4
Agree with leo that this is not a blocker as written. Not perfect, but not a blocker. Let's improve in 1.2
blocking-b2g: leo? → koi?
Priority: -- → P1
Whiteboard: [EU_TPE_TRIAGED] leorun3, leorun4 → [EU_TPE_TRIAGED] leorun3, leorun4, retest_leorun4
Thanks, Alex. There is a substantial 1.2 backlog for Bluetooth sharing and transfers, in the Communications component area, so 1.2 definitely contains a host of improvements here.
Flags: needinfo?(rmacdonald)
Flags: needinfo?(skasetti)
Hema, Let's add this to the 1.2 backlog.
We have been pushing this out for some time.
Flags: needinfo?(skasetti)
Yes, let's do this for 1.2.

Given that there is a back button and titlebar redesign coming, let's not put the share button in the titlebar, however.  I think the other option would be better in this case.
I agree with David that for now option 2 looks like a suitable solution.

Mahsa is going to implement this so assigning to her first.
Assignee: dkuo → mmojtahedi
Whiteboard: [EU_TPE_TRIAGED] leorun3, leorun4, retest_leorun4 → [EU_TPE_TRIAGED] leorun3, leorun4, retest_leorun4, mentor=dkuo
Flagging Rob and Jacqueline since I want to make sure UX understands, and is OK with, the move from option 1 (per Peter and Patryk) to option 2.
Flags: needinfo?(rmacdonald)
Flags: needinfo?(jsavory)
Attached file PR to master
Attachment #798221 - Flags: review?(dkuo)
Flags: needinfo?(pla)
Hi Peter, we need 1.5x and 2x images for bluetooth icon. Thanks.
Comment on attachment 798221 [details] [review]
PR to master

Mahsa,

Overall the patch looks good, but one major issue is that we should remove the original share function in music.js because you have moved it to the Player.js. I am cancelling the review request first, and after you addressed the issues I mentioned on github with the 1.5x and 2x images, feel free to assign to me again and I will take another look in detail, thanks.
Attachment #798221 - Flags: review?(dkuo)
blocking-b2g: koi? → ---
Target Milestone: --- → 1.2 FC (16sep)
Comment on attachment 798221 [details] [review]
PR to master

I updated the pull request. Thanks.
Attachment #798221 - Flags: review?(dkuo)
Mahsa,

I looked on the patch again, and overall it looks good, but I found one noticeable issue that should be easy to be discovered by the users, let's address it before I r+ this patch. And this bug is not a new feature so probably we don't need the tests because we just move the code from music.js to Player.js, but if it's possible and you already know how to write some unit tests, it will be nice to add some tests with this patch as well.
Attached file bluetooth icons.zip
Hi Mahsa, here are the bluetooth icons.  You'll need to update all three sizes, the current one used is out of date, we made the icons white instead of grey.  Thanks!
Flags: needinfo?(pla)
Hi Mahsa,

I've since spoken with Eric and we have decided to make these larger, and blue, consistent with our other permissions dialog icons, which are 64x64 @ 1x res.  One of our visual designers, Amy Lee, will be posting them here soon.
Hi Peter,

Ok, I'll wait for Amy to post the icons. Thanks.
Hi,

Attached are the revised icons + a screenshot showing placement.
Thank you. I will update the bluetooth icons. Could you please send me 1.5x and 2x res for share icon as well? 1x res is already attached to this bug.
Comment on attachment 798221 [details] [review]
PR to master

Mahsa,

I saw the changes you made on github and looks good to me, and as I said in comment 39, this issue is not a new feature but a bug fixing, so I think we can land this first then add the tests later, since we will have complete plans for testing media apps. And there are also some changes landed(bug 905856 and bug 838008), which are related to your patch, so you might need to rebase and resolve the conflict to your patch, after you fix that and add the 1.5x and 2x images, please needinfo me so that I can land it for you, thanks.
Attachment #798221 - Flags: review?(dkuo) → review+
Blocks: 878057
Hi Dominic,

I updated the patch with the latest, resolved the conflicts, added 1.5x and 2x share icons and updated the bluetooth icons. This bug should be good to go. Thanks.
Flags: needinfo?(dkuo)
Flags: needinfo?
Comment on attachment 798221 [details] [review]
PR to master

Nominating this bug for koi, because it is really broken that we don't have it already.

But giving r- because it breaks our Forward Lock DRM and allows locked songs to be shared.  Also because the CSS for the button doesn't seem right to me.
Attachment #798221 - Flags: review-
Comment on attachment 798221 [details] [review]
PR to master

Thanks, Mahsa!
Attachment #798221 - Flags: review- → review+
Landed to master: https://github.com/mozilla-b2g/gaia/commit/1274739fb0eb2b54bb7747bbd5cc110efcd9cdf8

Nominating for koi. This bug was tef+ at one point, so we should not let it slip to 1.3.  Also, it is needed for the ringtones patch in 878057 which we want to uplift also.
Status: NEW → RESOLVED
blocking-b2g: --- → koi?
Closed: 6 years ago
Flags: needinfo?
Resolution: --- → FIXED
Cancelling ni because it's already landed.
Flags: needinfo?(dkuo)
Attachment mime type: text/plain → text/x-github-pull-request
blocking-b2g: koi? → koi+
Sorry for the delay. Clearing my needs info.
Flags: needinfo?(rmacdonald)
Flags: needinfo?(jsavory)
Uplifted 1274739fb0eb2b54bb7747bbd5cc110efcd9cdf8 to:
v1.2: 0f3076f737289ebcaf94ad28285b938b1e6eb7b8
You need to log in before you can comment on or make changes to this bug.